package exnihilocreatio.tiles;

import exnihilocreatio.capabilities.CapabilityHeatManager;
import exnihilocreatio.networking.PacketHandler;
import exnihilocreatio.registries.CrucibleRegistryStone;
import exnihilocreatio.registries.HeatRegistry;
import exnihilocreatio.util.BlockInfo;
import exnihilocreatio.util.ItemInfo;
import net.minecraft.block.state.IBlockState;
import net.minecraft.init.Blocks;
import net.minecraft.item.ItemStack;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.math.BlockPos;
import net.minecraftforge.fluids.FluidRegistry;
import net.minecraftforge.fluids.FluidStack;

public class TileCrucibleStone extends TileCrucibleBase<CrucibleRegistryStone> {

    @Override
    public void func_73660_a() {
        if (func_145831_w().field_72995_K)
            return;

        ticksSinceLast++;

        if (ticksSinceLast >= 10) {
            ticksSinceLast = 0;

            int heatRate = getHeatRate();

            if (heatRate <= 0)
                return;

            if (solidAmount <= 0) {
                if (!itemHandler.getStackInSlot(0).func_190926_b()) {
                    currentItem = new ItemInfo(itemHandler.getStackInSlot(0));
                    itemHandler.getStackInSlot(0).func_190918_g(1);

                    if (itemHandler.getStackInSlot(0).func_190926_b()) {
                        itemHandler.setStackInSlot(0, ItemStack.field_190927_a);
                    }

                    solidAmount = CrucibleRegistryStone.getMeltable(currentItem).getAmount();
                } else {
                    if (currentItem != null) {
                        currentItem = null;

                        PacketHandler.sendNBTUpdate(this);
                    }

                    return;
                }
            }

            if (!itemHandler.getStackInSlot(0).func_190926_b() && itemHandler.getStackInSlot(0).func_77969_a(currentItem.getItemStack())) {
                // For meltables with a really small "amount"
                while (heatRate > solidAmount && !itemHandler.getStackInSlot(0).func_190926_b()) {
                    solidAmount += CrucibleRegistryStone.getMeltable(currentItem).getAmount();
                    itemHandler.getStackInSlot(0).func_190918_g(1);

                    if (itemHandler.getStackInSlot(0).func_190926_b()) {
                        itemHandler.setStackInSlot(0, ItemStack.field_190927_a);
                    }
                }
            }

            // Never take more than we have left
            if (heatRate > solidAmount) {
                heatRate = solidAmount;
            }

            if (heatRate > 0 && currentItem != null && CrucibleRegistryStone.canBeMelted(currentItem)) {
                FluidStack toFill = new FluidStack(FluidRegistry.getFluid(CrucibleRegistryStone.getMeltable(currentItem).getFluid()), heatRate);
                int filled = tank.fillInternal(toFill, true);
                solidAmount -= filled;

                if (filled > 0) {
                    PacketHandler.sendNBTUpdate(this);
                }
            }
        }
    }

    public int getHeatRate() {
        BlockPos posBelow = field_174879_c.func_177982_a(0, -1, 0);
        IBlockState stateBelow = func_145831_w().func_180495_p(posBelow);

        if (stateBelow == Blocks.field_150350_a.func_176223_P()) {
            return 0;
        }

        int heat = HeatRegistry.getHeatAmount(new BlockInfo(stateBelow));

        if (heat != 0) {
            return heat;
        }

        TileEntity tile = func_145831_w().func_175625_s(posBelow);

        if (tile != null && tile.hasCapability(CapabilityHeatManager.HEAT_CAPABILITY, EnumFacing.UP)) {
            return tile.getCapability(CapabilityHeatManager.HEAT_CAPABILITY, EnumFacing.UP).getHeatRate();
        }

        return 0;
    }
}
